//+------------------------------------------------------------------+
//|                                       MACD Elder Impulse Max.mq4 |
//|                                                         MaxAgeNT |
//|                                         http:/forex.agent.zp.ua/ |
//|                                             mod diver by Mobidik |
//+------------------------------------------------------------------+
// MACD,     
//
#property  copyright "Copyright  2012, MaxAgeNT"
#property  link      "http://forex.agent.zp.ua/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 8

#property  indicator_color1  Green
#property  indicator_color2  Blue
#property  indicator_color3  Red 
#property  indicator_color4  SeaGreen
#property  indicator_color5  Yellow
#property  indicator_color6  Gold // Ivory
#property  indicator_color7  Green
#property  indicator_color8  Red

#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2
#property indicator_width4   1
#property indicator_width5   1
#property indicator_width6   1

//---- indicator parameters

extern int FastEMA_Period=8; //   FastEMA
extern int FastMA_Period=12;  // FastMA MACD
extern int SlowMA_Period=26;  // SlowMA MACD
extern int SignalMA_Period=8; // SignalMA MACD
extern int TimeFrame=0;      // FastMA + SlowMA Timeframe = 1 or 5 / 15 / 30 / etc. 

extern bool   drawIndicatorTrendLines = true;
extern bool   drawPriceTrendLines = true;
extern bool   displayAlert = true;

int FastMA_Shift=0;
int FastMA_Method=1;
int FastMA_Price=0;
int SlowMA_Shift=0;
int SlowMA_Method=1;
int SlowMA_Price=0;
int SignalMA_Shift=0;
int SignalMA_Method=0;

//---- indicator buffers

double     macd[];
double     signal[];

double     ExtBuffer1[];
double     ExtBuffer2[];
double     ExtBuffer3[];
double     ExtBuffer4[];

double bullishDivergence[];
double bearishDivergence[];
#define arrowsDisplacement 0.0001

int Shift;
int MA_Period;
static datetime lastAlertTime;
static string   indicatorName;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   if (FastMA_Price>6 || FastMA_Price<0) FastMA_Price=0;
   if (FastMA_Method>3 || FastMA_Method<0) FastMA_Method=1;
   if (FastMA_Period<=0) FastMA_Period=12;
   if (SlowMA_Price>6 || SlowMA_Price<0) SlowMA_Price=0;
   if (SlowMA_Method>3 || SlowMA_Method<0) SlowMA_Method=1;
   if (SlowMA_Period<=0) SlowMA_Period=26;
   if (SignalMA_Method>3 || SignalMA_Method<0) SignalMA_Method=0;
   if (SignalMA_Period<=0) SignalMA_Period=9;
   if (FastMA_Shift<0) FastMA_Shift=0;
   if (SlowMA_Shift<0) SlowMA_Shift=0;  
   if (FastMA_Shift>=SlowMA_Shift)
     {
      Shift=FastMA_Shift;
     }
   else 
     {
      Shift=SlowMA_Shift;
     }
   if (FastMA_Period>=SlowMA_Period)
     {
      FastMA_Period=12;
      SlowMA_Period=26;
     }  
   if (SignalMA_Period>=SlowMA_Period)
     {
      MA_Period=SignalMA_Period;
     }
   else 
     {
      MA_Period=SlowMA_Period;
     }  
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexDrawBegin(0,MA_Period+Shift+4*SignalMA_Period);
   SetIndexBuffer(0,ExtBuffer1);
   
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexDrawBegin(1,MA_Period+Shift+4*SignalMA_Period);
   SetIndexBuffer(1,ExtBuffer2);
   
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexDrawBegin(2,MA_Period+Shift+4*SignalMA_Period);
   SetIndexBuffer(2,ExtBuffer3);
   
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexDrawBegin(3,MA_Period+Shift+4*SignalMA_Period);
   SetIndexBuffer(3,ExtBuffer4);
   
   SetIndexStyle(4,DRAW_NONE);
   SetIndexDrawBegin(4,MA_Period+Shift+4*SignalMA_Period);
   SetIndexBuffer(4,macd);
   
   SetIndexStyle(5,DRAW_LINE);
   SetIndexDrawBegin(5,MA_Period+Shift+4*SignalMA_Period);
   SetIndexBuffer(5,signal);
   SetIndexShift(5,SignalMA_Shift);
   
   SetIndexBuffer(6, bullishDivergence);
   SetIndexStyle (6, DRAW_ARROW);
   SetIndexArrow (6, 233);
   
   SetIndexBuffer(7, bearishDivergence);
   SetIndexStyle (7, DRAW_ARROW);
   SetIndexArrow (7, 234);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   
//---- name for DataWindow and indicator subwindow label
   indicatorName = "MACD_ElderImpulseMax_Divergence ("+FastEMA_Period+","+FastMA_Period+","+SlowMA_Period+","+SignalMA_Period+")";
   IndicatorShortName(indicatorName);
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,"maxMACDcolor");
   SetIndexLabel(5,"Signal");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
     {
       string label = ObjectName(i);
       if(StringSubstr(label, 0, 19) != "MACD_DivergenceLine")
           continue;
       ObjectDelete(label);   
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   double prev,current, Sprev,Scurrent;
   int counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;




   for(int i=0; i<limit; i++)
   {
         macd[i]=iMA(Symbol(),TimeFrame,FastMA_Period,FastMA_Shift,FastMA_Method,FastMA_Price,i) - 
         iMA(Symbol(),TimeFrame,SlowMA_Period,SlowMA_Shift,SlowMA_Method,SlowMA_Price,i);

   }

   for( int j = 0; j <= limit-1;   j++)
   {
       signal[j]=iMAOnArray(macd,Bars,SignalMA_Period,0,SignalMA_Method,j);
   }


   for(i=0, j = 0; i <= limit-1; i++ , j++)
   {

      current=macd[i];
      prev=macd[i+1];
      
      Scurrent = iMA(NULL,0,FastEMA_Period,0,MODE_EMA,PRICE_CLOSE,i);
      Sprev = iMA(NULL,0,FastEMA_Period,0,MODE_EMA,PRICE_CLOSE,i+1);

    
      ExtBuffer1[i]=0.0; 
      ExtBuffer2[i]=0.0;
      ExtBuffer3[i]=0.0;
      ExtBuffer4[i]=0.0;
/*
1)  FastEMA -   ;
       -    -  .

2)  FastEMA -   ; 
       -     -  .

3)  FastEMA -    ; 
       -    -  ,

4)  FastEMA -   ; 
       -    -  .

5)  FastEMA -    ;
      -     -  . 

6)  FastEMA  -   ; 
       -    -  .

7)  FastEMA  -   ; 
       -    -  . 

8) FastEMA -    ;
      -     -  . 

9)  FastEMA  -   ; 
       -     -  .
*/
      if(( current > prev) && (Scurrent > Sprev) )
      {
         ExtBuffer1[i]=current; // Green
         ExtBuffer2[i]=0.0;
         ExtBuffer3[i]=0.0;
         ExtBuffer4[i]=0.0;
      }
      else
      if( ( current< prev) && (Scurrent < Sprev)   ) // 
      {
         ExtBuffer1[i]=0.0; 
         ExtBuffer2[i]=0.0; 
         ExtBuffer3[i]=current; // // Red
         ExtBuffer4[i]=0.0;
      }
      else
      if( (current > prev)&& (Scurrent < Sprev)  ) 
      {
         ExtBuffer1[i]=0.0; 
         ExtBuffer2[i]=current; // MediumBlue
         ExtBuffer3[i]=0.0;  
         ExtBuffer4[i]=0.0;
      }
      else
      if( (current < prev)&& (Scurrent > Sprev)  ) 
      {
         ExtBuffer1[i]=0.0; 
         ExtBuffer2[i]=current; // MediumBlue
         ExtBuffer3[i]=0.0;  
         ExtBuffer4[i]=0.0;
      }
   }
   for(i = limit; i >= 0; i--)
     {
       CatchBullishDivergence(i + 2);
       CatchBearishDivergence(i + 2);
     } 
   return(0);
}
//+------------------------------------------------------------------+
void CatchBullishDivergence(int shift)
  {
   if(IsIndicatorTrough(shift) == false)
       return;  
   int currentTrough = shift;
   int lastTrough = GetIndicatorLastTrough(shift);
//----   
   if(macd[currentTrough] > macd[lastTrough] && 
      Low[currentTrough] < Low[lastTrough])
     {
       bullishDivergence[currentTrough] = macd[currentTrough] - 
                                          arrowsDisplacement;
       //----
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentTrough], Time[lastTrough], 
                              Low[currentTrough], 
                             Low[lastTrough], Green, STYLE_SOLID);
       //----
       if(drawIndicatorTrendLines == true)
          DrawIndicatorTrendLine(Time[currentTrough], 
                                 Time[lastTrough], 
                                 macd[currentTrough],
                                 macd[lastTrough], 
                                 Green, STYLE_SOLID);
       //----
       if(displayAlert == true)
          DisplayAlert("Classical bullish divergence on: ", 
                        currentTrough);  
     }
//----   
   if(macd[currentTrough] < macd[lastTrough] && 
      Low[currentTrough] > Low[lastTrough])
     {
       bullishDivergence[currentTrough] = macd[currentTrough] - 
                                          arrowsDisplacement;
       //----
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentTrough], Time[lastTrough], 
                              Low[currentTrough], 
                              Low[lastTrough], Green, STYLE_DOT);
       //----
       if(drawIndicatorTrendLines == true)                            
           DrawIndicatorTrendLine(Time[currentTrough], 
                                  Time[lastTrough], 
                                  macd[currentTrough],
                                  macd[lastTrough], 
                                  Green, STYLE_DOT);
       //----
       if(displayAlert == true)
           DisplayAlert("Reverse bullish divergence on: ", 
                        currentTrough);   
     }      
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CatchBearishDivergence(int shift)
  {
   if(IsIndicatorPeak(shift) == false)
       return;
   int currentPeak = shift;
   int lastPeak = GetIndicatorLastPeak(shift);
//----   
   if(macd[currentPeak] < macd[lastPeak] && 
      High[currentPeak] > High[lastPeak])
     {
       bearishDivergence[currentPeak] = macd[currentPeak] + 
                                        arrowsDisplacement;
      
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentPeak], Time[lastPeak], 
                              High[currentPeak], 
                              High[lastPeak], Red, STYLE_SOLID);
                            
       if(drawIndicatorTrendLines == true)
           DrawIndicatorTrendLine(Time[currentPeak], Time[lastPeak], 
                                  macd[currentPeak],
                                  macd[lastPeak], Red, STYLE_SOLID);

       if(displayAlert == true)
           DisplayAlert("Classical bearish divergence on: ", 
                        currentPeak);  
     }
   if(macd[currentPeak] > macd[lastPeak] && 
      High[currentPeak] < High[lastPeak])
     {
       bearishDivergence[currentPeak] = macd[currentPeak] + 
                                        arrowsDisplacement;
       //----
       if(drawPriceTrendLines == true)
           DrawPriceTrendLine(Time[currentPeak], Time[lastPeak], 
                              High[currentPeak], 
                              High[lastPeak], Red, STYLE_DOT);
       //----
       if(drawIndicatorTrendLines == true)
           DrawIndicatorTrendLine(Time[currentPeak], Time[lastPeak], 
                                  macd[currentPeak],
                                  macd[lastPeak], Red, STYLE_DOT);
       //----
       if(displayAlert == true)
           DisplayAlert("Reverse bearish divergence on: ", 
                        currentPeak);   
     }   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsIndicatorPeak(int shift)
  {
   if(macd[shift] >= macd[shift+1] && macd[shift] > macd[shift+2] && 
      macd[shift] > macd[shift-1])
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsIndicatorTrough(int shift)
  {
   if(macd[shift] <= macd[shift+1] && macd[shift] < macd[shift+2] && 
      macd[shift] < macd[shift-1])
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetIndicatorLastPeak(int shift)
  {
   for(int i = shift + 5; i < Bars; i++)
     {
       if(signal[i] >= signal[i+1] && signal[i] >= signal[i+2] &&
          signal[i] >= signal[i-1] && signal[i] >= signal[i-2])
         {
           for(int j = i; j < Bars; j++)
             {
               if(macd[j] >= macd[j+1] && macd[j] > macd[j+2] &&
                  macd[j] >= macd[j-1] && macd[j] > macd[j-2])
                   return(j);
             }
         }
     }
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetIndicatorLastTrough(int shift)
  {
    for(int i = shift + 5; i < Bars; i++)
      {
        if(signal[i] <= signal[i+1] && signal[i] <= signal[i+2] &&
           signal[i] <= signal[i-1] && signal[i] <= signal[i-2])
          {
            for (int j = i; j < Bars; j++)
              {
                if(macd[j] <= macd[j+1] && macd[j] < macd[j+2] &&
                   macd[j] <= macd[j-1] && macd[j] < macd[j-2])
                    return(j);
              }
          }
      }
    return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DisplayAlert(string message, int shift)
  {
   if(shift <= 2 && Time[shift] != lastAlertTime)
     {
       lastAlertTime = Time[shift];
       Alert(message, Symbol(), " , ", Period(), " minutes chart");
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawPriceTrendLine(datetime x1, datetime x2, double y1, 
                        double y2, color lineColor, double style)
  {
   string label = "MACD_DivergenceLine_v1.0# " + DoubleToStr(x1, 0);
   ObjectDelete(label);
   ObjectCreate(label, OBJ_TREND, 0, x1, y1, x2, y2, 0, 0);
   ObjectSet(label, OBJPROP_RAY, 0);
   ObjectSet(label, OBJPROP_COLOR, lineColor);
   ObjectSet(label, OBJPROP_STYLE, style);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawIndicatorTrendLine(datetime x1, datetime x2, double y1, 
                            double y2, color lineColor, double style)
  {
   int indicatorWindow = WindowFind(indicatorName);
   if(indicatorWindow < 0)
       return;
   string label = "MACD_DivergenceLine_v1.0$# " + DoubleToStr(x1, 0);
   ObjectDelete(label);
   ObjectCreate(label, OBJ_TREND, indicatorWindow, x1, y1, x2, y2, 
                0, 0);
   ObjectSet(label, OBJPROP_RAY, 0);
   ObjectSet(label, OBJPROP_COLOR, lineColor);
   ObjectSet(label, OBJPROP_STYLE, style);
  }
//+------------------------------------------------------------------+